DROP TABLE IF EXISTS PERF_CONFIGURATION_CONFIGURATIONS;

DROP TABLE IF EXISTS PERF_SETTING_THRESHOLDS;

DROP TABLE IF EXISTS PERF_CONFIGURATION_SETTINGS;

DROP TABLE IF EXISTS PERF_SETTING;

DROP TABLE IF EXISTS PERF_CONFIGURATION;

CREATE TABLE PERF_CONFIGURATION
  (
     CONFIGURATION_ID INT auto_increment,
     ACTIVE           TINYINT,
     CREATED          TIMESTAMP,
     CREATED_BY       VARCHAR(255),
     DOMAIN           VARCHAR(255),
     EDITED_BY        VARCHAR(255),
     CONF_KEY         VARCHAR(255),
     CONF_LABEL       VARCHAR(255),
     MODIFIED         TIMESTAMP,
     TOP_LEVEL        TINYINT,
     VALID_FROM       TIMESTAMP,
     VALID_TO         TIMESTAMP,
     PRIMARY KEY (CONFIGURATION_ID)
  )
engine = innodb;

CREATE TABLE PERF_SETTING
  (
     SETTING_ID    INT auto_increment,
     SETTING_TYPE  VARCHAR(255) NOT NULL,
     ORDINAL       INT,
     SETTING_KEY   VARCHAR(255),
     SETTING_LABEL VARCHAR(255),
     VALUE_TYPE    VARCHAR(255),
     VALUE         VARCHAR(255),
     CAPTION       VARCHAR(255),
     RELATION      VARCHAR(255),
     PRIMARY KEY (SETTING_ID)
  )
engine = innodb;

CREATE TABLE PERF_CONFIGURATION_SETTINGS
  (
     CONFIGURATION_ID INT NOT NULL,
     SETTINGS_ID      INT NOT NULL,
     FOREIGN KEY (CONFIGURATION_ID) REFERENCES PERF_CONFIGURATION (
     CONFIGURATION_ID) ON DELETE CASCADE,
     FOREIGN KEY (SETTINGS_ID) REFERENCES PERF_SETTING (SETTING_ID) ON DELETE
     CASCADE,
     PRIMARY KEY (CONFIGURATION_ID,SETTINGS_ID)
  )
engine = innodb;

CREATE TABLE PERF_SETTING_THRESHOLDS
  (
     THRESHOLD_SET_ID INT NOT NULL,
     THRESHOLDS_ID    INT NOT NULL,
     FOREIGN KEY (THRESHOLD_SET_ID) REFERENCES PERF_SETTING (SETTING_ID) ON
     DELETE CASCADE,
     FOREIGN KEY (THRESHOLDS_ID) REFERENCES PERF_SETTING (SETTING_ID) ON DELETE
     CASCADE,
     PRIMARY KEY (THRESHOLD_SET_ID,THRESHOLDS_ID)
  )
engine = innodb;

CREATE TABLE PERF_CONFIGURATION_CONFIGURATIONS
  (
     CONFIGURATION_ID  INT NOT NULL,
     CONFIGURATIONS_ID INT NOT NULL,
     FOREIGN KEY (CONFIGURATION_ID) REFERENCES PERF_CONFIGURATION (
     CONFIGURATION_ID) ON DELETE CASCADE,
     FOREIGN KEY (CONFIGURATIONS_ID) REFERENCES PERF_CONFIGURATION (
     CONFIGURATION_ID) ON DELETE CASCADE,
     PRIMARY KEY (CONFIGURATION_ID,CONFIGURATIONS_ID)
  )
engine = innodb;

CREATE INDEX PERF_CONFIGURATION_SETTINGS_IDX1 ON PERF_CONFIGURATION_SETTINGS (CONFIGURATION_ID);
CREATE INDEX PERF_SETTING_THRESHOLDS_IDX1 ON PERF_SETTING_THRESHOLDS (THRESHOLD_SET_ID);
